# Arrays

Dates: 05/28/2017

See [http://charlesreid1.com/wiki/Arrays](http://charlesreid1.com/wiki/Arrays)

## Content

Listsize scrips are exploring the way that lists change size as we add/remove items from them.

DynamicArray implements an array-based data structure that uses dynamic resizing
and an underlying low-level ctype array to store data.

CaesarCipher implements a Caesar cipher using string manpiulation methods.

`amortized-append-cost.py` computes the amortized cost of resizing the underlying
array for a Python list type, and demonstrates that it is O(1), independent of n.

## Mistakes/Learnings

List size:
* `sys.getsizeof()` to get size of item in bits of memory
* when plotting the results - I was already able to apply learnings
* Whatever you do, specify the size of your data structures if you know them!!!

DynamicArray:
* What it teaches you:
	* how to use some of the underscore methods
	* how to provide indexing access [] to an arbitrary object
	* how to design a class with public/private fields/methods
	* how to organize your code
* Nice application of the `if __name__=="__main__":` clause for driver/test
* Underscore before method or field name means, it is private
* Constructor should have nice short sweet comments, minimal initialization
* Whatever you do, specify the size of your data structures if you know them!!!

Caesar Cipher
* Switching languages (Python to Java) is not trivial. Don't neglect the basics.
* Transforming from int to char and back again requires two functions, chr and ord
* ord('A') -> integer
* chr(z) -> character
* Use list comprehensions. Use optimal data structures. 
* Store things once to reuse again. Think ahead.

Amortized append:
* So much to learn about strings. String formatting. everything is so different.
* See [https://docs.python.org/3/library/string.html#formatstrings](https://docs.python.org/3/library/string.html#formatstrings)
* Being precise, being conservative, using integers and not floats 
* Example: dividing by microsecond = multiplying by 100000: `INV_MICROSECOND=10**6`
* Keep it integer, know your bytes.

Fisher Yates Shuffle:
* I am SUPER awkward with Python.
* Focus on the ability to translate algorithms from Java into Python or vice versa.
* Algorithm to code relies on practicing the basics.
* Fisher Yates: basics was, not using a bunch of fancy stuff like reverse or built-in list iterator stuff
* We have seen this problem before. Don't get paralyzed by the built-in iteration schema.
* If you need to implement a fancy for loop, just make it a while loop.
* If you need your own counter to start high and decrease, by all means, take care of it.

Dynamic Array pop operation:
* Think through the subtleties.
* Think through the other parts of the problem that are not stated.

Find five:
* Be careful with your index math!
* Distinguish between finding *which* duplicates, and finding *where* duplicates
* We desperately need better strategies for handling tests, assertions, and conditions.




























