import sys
from array import array

"""
Goodrich et al
Data Structures in Python
Chapter 5: Array-Based Sequences

Exploring the use of compact arrays.
"""

n = int(1E3)
slow = [j for j in range(n)]
fast = array('i',[j for j in range(n)])
for i,j in zip(["list","array"],[slow,fast]):
    print("Size of {0} with {1} elements: {2:4d}".format(i,n,sys.getsizeof(j)))
