import random

"""
Goodrich et al
Data Structures in Python
Chapter 5: Array-Based Sequences

C-5.14

The shuffle method rearranges a list 
so that every arrangement is equally likely.

Use randrange to generate random indices,
and use this to shuffle the list.
"""

def fisher_yates(arr):
    n = len(arr)
    countdown = list(range(n))
    k = n-1
    while(k>0):
        j = random.randrange(0,k)
        temp = arr[k]
        arr[k] = arr[j]
        arr[j] = temp
        k -= 1
    return arr


if __name__=="__main__":
    n = 10
    z = list(range(n))


    print("Before:")
    print(z)

    z = fisher_yates(z)

    print("After:")
    print(z)