from ArrayDeque import ArrayDeque

"""
Goodrich et al Data Structures in Python: Chapter 6
Stacks Queues and Deques

Question R-6.11

Give simple adapter for Queue ADT that uses a deque under the hood.

Using the ArrayDeque type...

Queue ADT must implement:
* enqueue
* dequeue
* first
* is_empty
* len(Q)
"""


class QueueAdapter:
    """
    enqueue
    dequeue
    first
    is_empty
    len(Q)
    """
    def __init__(self):
        self._data = ArrayDeque()
    
    def __len__(self):
        return len(self._data)

    def __str__(self):
        return str(self._data)

    def enqueue(self,e):
        self._data.add_last(e)

    def dequeue(self):
        return self._data.delete_first()
    
    def first(self):
        return self._data.first()
    
    def is_empty(self):
        return self._data.is_empty()


if __name__=="__main__":
    a = QueueAdapter()
    for c in "ABCDEFGHIJKLMNOPQRSTUVWX":
        a.enqueue(c)
        print(a)
    for i in range(15):
        a.dequeue()
        print(a)
    for c in "9876543":
        a.enqueue(c)
        print(a)
    for i in range(8):
        a.dequeue()
        print(a)
    print("Final:")
    print(a)