from ArrayStack import ArrayStack

def reverse_order(R):
    """Reverses the order of the elements in stack R, in-place."""
    # Uses 2 stacks, O(N) space
    S = ArrayStack()
    T = ArrayStack()

    # O(N) ops
    copy_into(R,S)
    copy_into(S,T)
    copy_into(T,R)

def copy_into(A,B):
    while(not A.is_empty()):
        B.push(A.pop())

if __name__=="__main__":
    R = ArrayStack()
    letters = list("ABGCDFE")
    letters = sorted(letters)

    for c in letters:
        R.push(c)
    print("Original:")
    print(R)

    print("Reversed:")
    reverse_order(R)
    print(R)