"""
Compute the greatest common factor of two numbers via Euclid's Algorithm.
"""

def gcf(a, b):
    if a<0 or b<0:
        raise Exception("Error: a and b must be positive.")

    while b is not 0:
        t = b
        b = a%b
        a = t
    return a

if __name__=="__main__":
    print("gcf of 12345 and 11111: {0:d}".format(gcf(12345,11111)))
    print("gcf of 1024 and 4096: {0:d}".format(gcf(1024,4096)))
    try:
        print("gcf of -4 and -5: {0:d}".format(gcf(-4,-5)))
    except Exception:
        print("Successfully caught exception executing gcd(-4,-5)")
